<template>
  <div class="centre">
    <div style="display:flex;justify-content: center;align-items: center;">
      <h4>今日统计</h4>
    </div>
    <div class="top">
      <div class="add">
        <div class="img">
          <img class="image" src="../assets/images/jrbg.png" alt="" />
        </div>
        <div class="txt">
          <div class="day">今日登记 {{ Customer }}</div>
        </div>
      </div>
      <div class="add">
        <div class="img">
          <img class="image" src="../assets/images/jrdj.png" alt="" />
        </div>
        <div class="txt">
          <div class="day">今日已检 {{ Order }}</div>
        </div>
      </div>
      <div class="add">
        <div class="img">
          <img class="image" src="../assets/images/jrwj.png" alt="" />
        </div>
        <div class="txt">
          <div class="day">今日报告 {{ ReportToday }}</div>
        </div>
      </div>
      <div class="add">
        <div class="img">
          <img class="image" src="../assets/images/jryj.png" alt="" />
        </div>
        <div class="txt">
          <div class="day">今日待检 {{ TobeToday }}</div>
        </div>
      </div>
    </div>
     <div style="display:flex;justify-content: center;align-items: center;">
      <h4>近一月统计</h4>
    </div>
    <div class="data-view">
      <div id="main" style="width:95%;height:330px"></div>
    </div>
    <div class="view">
      <div id="main2"></div>
      <div id="main3"></div>
    </div>
  </div>
</template>

<script>
import { getCustomer, getOrder, getReportToday, getTobeToday, getPieChart, getChart } from "@/api/home";
const echarts = require('echarts/lib/echarts');
require('echarts/lib/component/title');
require('echarts/lib/component/tooltip');
require('echarts/lib/component/legend');
require('echarts/lib/chart/pie');

export default {
  data() {
    return {
      min: '',
      max: '',
      Customer: "",
      Order: "",
      ReportToday: "",
      TobeToday: "",
      LineChart: [],
      personYYNum: [],
      reportNum: [],
      teamYYNum: [],
      PieChart: [],
      PieChart2: [],
    }
  },

  created() {
    this.getList();

  },
  watch: {
        $route(to, from) {
            window.location.reload(); //监测到路由发生跳转时刷新一次页面
            // this.$router.go(0);
        },
    },
 

  methods: {
 
    getList() {
      this.loading = true;
      // 查询今日登记
      getCustomer().then((response) => {
        this.Customer = response
        this.loading = false;
      });
      // 查询今日已检
      getOrder().then((response) => {
        this.Order = response
        this.loading = false;
      });
      // 查询今日报告
      getReportToday().then((response) => {
        this.ReportToday = response
        this.loading = false;
      });
      // 查询今日待检
      getTobeToday().then((response) => {
        this.TobeToday = response
        this.loading = false;
      });
      // 折线图
      getChart().then((response) => {
        response.data.forEach(item => {
          this.LineChart.push(item.date)
          this.reportNum.push(item.tdcoun);
          this.personYYNum.push(item.grcoun);
          this.teamYYNum.push(item.bgcoun);

        });
        let myChart = this.$echarts.init(document.getElementById('main'));

        myChart.setOption({
          tooltip: {
            trigger: 'axis'
          },
          legend: {
            data: ['每日体检登记数', '每日团体登记数', '每日发布报告数']
          },
          grid: {
            left: '3%',
            right: '4%',
            bottom: '3%',
            containLabel: true
          },
          toolbox: {
            feature: {
              saveAsImage: {}
            }
          },
          xAxis: {
            type: 'category',
            boundaryGap: false,
            axisLine: {
              show: true,
              lineStyle: {
                color: "blue",
                size: 12,
                width: 0,
                tyle: "solid"
              }
            },
            data: this.LineChart
          },
          yAxis: {
            type: 'value',
            min: 0,
            max: 400,
            interval: 20
          },
          series: [
            {
              name: '每日体检登记数',
              type: 'line',
              stack: 'Total',
              data: this.personYYNum
            },
            {
              name: '每日团体登记数',
              type: 'line',
              stack: 'Total',
              data: this.reportNum
            },
            {
              name: '每日发布报告数',
              type: 'line',
              stack: 'Total',
              data: this.teamYYNum
            },
          ]

        })
        let sizeFun =  ()=> {
          myChart.resize()
        }
        window.addEventListener("resize", sizeFun)

        this.loading = false;
      });

      // 饼状图
      getPieChart().then((response) => {
        if (response.data) {

          if(response.data.tjdj == 0){
            this.PieChart = []
            this.PieChart = [
              {
                "name": "体检登记人数分布",
                "count": 1,
                "value": 10
              },

            ]
          }else if (response.data.tjdj.length === 0) {

            this.PieChart = []
            this.PieChart = [
              {
                "name": "体检登记人数分布",
                "count": 1,
                "value": 10
              },

            ]
          } else {
            this.PieChart = response.data.tjdj
            this.PieChart.forEach(item => {
              item.value = item.count
            })
            this.PieChart.reverse()
            this.PieChart.push(this.PieChart[0])
            this.PieChart.splice(0, 1)

          }

          let myChart2 = this.$echarts.init(document.getElementById('main2'));
          myChart2.setOption({
            title: {
              text: '体检登记人数分布',
              top: '5'

            },

            tooltip: {
              trigger: 'item'
            },
            legend: {
              top: '80%',
              left: 'center'
            },
            series: [
              {
                // name: 'Access From',
                type: 'pie',
                radius: ['16%', '54%'],
                center: ["50%", "43%"],
                avoidLabelOveralap:false,
                startAngle:180,
                minAngle:10,
                data: this.PieChart,
                emphasis: {
                  itemStyle: {
                    shadowBlur: 10,
                    shadowOffsetX: 0,
                    shadowColor: 'rgba(0, 0, 0, 0.5)'
                  }
                }
              }]
          })

          if(response.data.tjyc == 0){
            this.PieChart2 = []
            this.PieChart2 = [
              {
                "name": "体检结果异常人数分布",
                "count": 1,
                "value": 0
              },

            ]
          }else if (response.data.tjyc.length === 0) {
            this.PieChart2 = []
            this.PieChart2 = [
              {
                "name": "体检结果异常人数分布",
                "count": 1,
                "value": 0
              },

            ]
          } else {
            this.PieChart2 = response.data.tjyc
            this.PieChart2.reverse()
            this.PieChart2.push(this.PieChart2[0])
            this.PieChart2.splice(0, 1)
            this.PieChart2.forEach(item => {
              item.value = item.count
            })
            // this.TobeToday = response
          }
          let myChart3 = this.$echarts.init(document.getElementById('main3'));

          myChart3.setOption({
            title: {
              text: '体检结果异常人数分布',
              top: '5'

            },
            tooltip: {
              trigger: 'item'
            },
            legend: {
              top: '80%',
              left: 'center'
            },
            series: [
              {
                // name: 'Access From',
                type: 'pie',
                radius: ['16%', '54%'],
                center: ["50%", "43%"],
                avoidLabelOveralap:false,
                startAngle:180,
                minAngle:10,
                data: this.PieChart2,
                emphasis: {
                  itemStyle: {
                    shadowBlur: 10,
                    shadowOffsetX: 0,
                    shadowColor: 'rgba(0, 0, 0, 0.5)'
                  }
                }
              }]
          })
          window.onresize =  () =>{
          myChart2.resize()
          myChart3.resize()
        }
        }


      
        this.loading = false;
      });

    }
  },


  mounted() {

  }
}


</script>

<style>
.centre {
  min-height: 820px;
  margin: 15px 15px;
  background-color: #f3f3f3;
  padding: 10px 10px 10px 10px;
}

.top {
  width: 100%;
  display: flex;
  height: 120px;

}

.add {
  width: 380px;
  height: 75px;
  margin-top: 30px;
  margin-left: 20px;
  margin-right: 20px;
  background-color: #fff;
  display: flex
}

.img {
  width: 60%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
}

.image {
  width: 60px;
  height: 60px;

}

.txt {
  display: flex;
  align-items: center;
}

.day {
  height: 40px;
  line-height: 40px;
  font-size: 12px;
}

.data-view {
  margin: 0 15px;
  height: 323px !important
}

#main {
  padding: 10px;
}

.view {
  margin: 0px 15px;
  padding-top: 15px;
  min-height: 350px;
  display: flex;
}

#main2 {
  width: 820px;
  height: 350px;
  background-color: #fff;
  margin-right: 20px;
}

#main3 {
  width: 820px;
  height: 350px;
  background-color: #fff;
  margin-right: 20px;
}
</style>